searchData={"content_type":"text/markdown","items":[{"doc":"Membrane element that decodes video in H264 format. It is backed by decoder from FFmpeg.\n\nThe element expects the data for each frame (Access Unit) to be received in a separate buffer,\nso the parser (`Membrane.H264.FFmpeg.Parser`) may be required in a pipeline before\ndecoder (e.g. when input is read from `Membrane.File.Source`).","ref":"Membrane.H264.FFmpeg.Decoder.html","title":"Membrane.H264.FFmpeg.Decoder","type":"module"},{"doc":"Passed via struct `t:Membrane.H264.FFmpeg.Decoder.t/0`\n\n- `use_shm?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`","ref":"Membrane.H264.FFmpeg.Decoder.html#module-element-options","title":"Element options - Membrane.H264.FFmpeg.Decoder","type":"module"},{"doc":"### `:input`\n\nAccepted formats:\n```\n%H264{alignment: :au}\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\nDemand unit: | `:buffers`\n\n\n### `:output`\n\nAccepted formats:\n```\n%RawVideo{pixel_format: format, aligned: true} when format in [:I420, :I422]\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`\nDemand unit: | `nil`","ref":"Membrane.H264.FFmpeg.Decoder.html#module-pads","title":"Pads - Membrane.H264.FFmpeg.Decoder","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.H264.FFmpeg.Decoder.html#options/0","title":"Membrane.H264.FFmpeg.Decoder.options/0","type":"function"},{"doc":"Struct containing options for `Membrane.H264.FFmpeg.Decoder`","ref":"Membrane.H264.FFmpeg.Decoder.html#t:t/0","title":"Membrane.H264.FFmpeg.Decoder.t/0","type":"type"},{"doc":"Membrane element that encodes raw video frames to H264 format.\n\nThe element expects each frame to be received in a separate buffer, so the parser\n(`Membrane.Element.RawVideo.Parser`) may be required in a pipeline before\nthe encoder (e.g. when input is read from `Membrane.File.Source`).\n\nAdditionally, the encoder has to receive proper stream_format with picture format and dimensions\nbefore any encoding takes place.\n\nPlease check `t:t/0` for available options.","ref":"Membrane.H264.FFmpeg.Encoder.html","title":"Membrane.H264.FFmpeg.Encoder","type":"module"},{"doc":"Passed via struct `t:Membrane.H264.FFmpeg.Encoder.t/0`\n\n- `crf`  \n\n  ```\n  0..63\n  ```\n  \n  Default value: `23`  \n  Constant rate factor that affects the quality of output stream.\n  Value of 0 is lossless compression while 51 (for 8-bit samples)\n  or 63 (10-bit) offers the worst quality.\n  The range is exponential, so increasing the CRF value +6 results\n  in roughly half the bitrate / file size, while -6 leads\n  to roughly twice the bitrate.\n\n\n- `preset`  \n\n  ```\n  preset()\n  ```\n  \n  Default value: `:medium`  \n  Collection of predefined options providing certain encoding.\n  The slower the preset chosen, the higher compression for the\n  same quality can be achieved.\n\n\n\n- `profile`  \n\n  ```\n  H264.profile_t() | nil\n  ```\n  \n  Default value: `nil`  \n  Sets a limit on the features that the encoder will use to the ones supported in a provided H264 profile.\n  Said features will have to be supported by the decoder in order to decode the resulting video.\n  It may override other, more specific options affecting compression (e.g setting `max_b_frames` to 2\n  while profile is set to `:baseline` will have no effect and no B-frames will be present).\n\n\n\n- `tune`  \n\n  ```\n  tune() | nil\n  ```\n  \n  Default value: `nil`  \n  Optionally tune the encoder settings for a particular type of source or situation.\n  See [`x264` encoder's man page](https://manpages.ubuntu.com/manpages/trusty/man1/x264.1.html) for more info.\n  Available options are:\n  - `:film` - use for high quality movie content; lowers deblocking\n  - `:animation` - good for cartoons; uses higher deblocking and more reference frames\n  - `:grain` - preserves the grain structure in old, grainy film material\n  - `:stillimage` - good for slideshow-like content\n  - `:fastdecode` - allows faster decoding by disabling certain filters\n  - `:zerolatency` - good for fast encoding and low-latency streaming\n\n\n\n- `use_shm?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`  \n  \n\n\n\n- `max_b_frames`  \n\n  ```\n  non_neg_integer() | nil\n  ```\n  \n  Default value: `nil`  \n  Maximum number of B-frames between non-B-frames. Set to 0 to encode video without b-frames\n\n\n\n- `gop_size`  \n\n  ```\n  non_neg_integer() | nil\n  ```\n  \n  Default value: `nil`  \n  Number of frames in a group of pictures.","ref":"Membrane.H264.FFmpeg.Encoder.html#module-element-options","title":"Element options - Membrane.H264.FFmpeg.Encoder","type":"module"},{"doc":"### `:input`\n\nAccepted formats:\n```\n%RawVideo{pixel_format: format, aligned: true} when format in [:I420, :I422]\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\nDemand unit: | `:buffers`\n\n\n### `:output`\n\nAccepted formats:\n```\n%H264{alignment: :au}\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`\nDemand unit: | `nil`","ref":"Membrane.H264.FFmpeg.Encoder.html#module-pads","title":"Pads - Membrane.H264.FFmpeg.Encoder","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.H264.FFmpeg.Encoder.html#options/0","title":"Membrane.H264.FFmpeg.Encoder.options/0","type":"function"},{"doc":"","ref":"Membrane.H264.FFmpeg.Encoder.html#t:preset/0","title":"Membrane.H264.FFmpeg.Encoder.preset/0","type":"type"},{"doc":"Struct containing options for `Membrane.H264.FFmpeg.Encoder`","ref":"Membrane.H264.FFmpeg.Encoder.html#t:t/0","title":"Membrane.H264.FFmpeg.Encoder.t/0","type":"type"},{"doc":"","ref":"Membrane.H264.FFmpeg.Encoder.html#t:tune/0","title":"Membrane.H264.FFmpeg.Encoder.tune/0","type":"type"},{"doc":"Membrane element providing parser for H264 encoded video stream.\nUses the parser provided by FFmpeg.\n\nBy default, this parser splits the stream into h264 access units,\neach of which is a sequence of NAL units corresponding to one\nvideo frame, and equips them with the following metadata entries\nunder `:h264` key:\n- `key_frame?: boolean` - determines whether the frame is a h264\n  I frame.\n\nSetting custom packetization options affects metadata, see `alignment`\nand `attach_nalus?` options for details.\n\nThis Parser is also capable of handling out-of-band parameters in the form of Decoder Configuration Record.\nTo inject it, simply send `t:Membrane.H264.RemoteStream.t/0` stream_format containing the Decoder Configuration Record to this element.\nThere are however some limitations:\n- `t:Membrane.H264.RemoteStream.t/0` stream_format needs to be send only before the first buffer.\n  Sending them during the stream will cause an error\n- SPS and PPS will be extracted from Decoder Configuration Record and added to the payload of the very first buffer without any checks of in-band parameters.\n  This might result in duplicated SPS and PPS. It shouldn't be a problem, unless you send an incorrect Decoder Configuration Record that doesn't match the stream.","ref":"Membrane.H264.FFmpeg.Parser.html","title":"Membrane.H264.FFmpeg.Parser","type":"module"},{"doc":"Passed via struct `t:Membrane.H264.FFmpeg.Parser.t/0`\n\n- `framerate`  \n\n  ```\n  H264.framerate_t() | nil\n  ```\n  \n  Default value: `nil`  \n  Framerate of video stream, see `t:Membrane.H264.framerate_t/0`\n\n\n- `sps`  \n\n  ```\n  binary()\n  ```\n  \n  Default value: `\"\"`  \n  Sequence Parameter Set NAL unit - if absent in the stream, should\n  be provided via this option.\n\n\n\n- `pps`  \n\n  ```\n  binary()\n  ```\n  \n  Default value: `\"\"`  \n  Picture Parameter Set NAL unit - if absent in the stream, should\n  be provided via this option.\n\n\n\n- `alignment`  \n\n  ```\n  :au | :nalu\n  ```\n  \n  Default value: `:au`  \n  Stream units carried by each output buffer. See `t:Membrane.H264.alignment_t/0`.\n  \n  If alignment is `:nalu`, the following metadata entries are added:\n  - `type` - h264 nalu type\n  - `new_access_unit: access_unit_metadata` - added whenever the new access unit starts.\n    `access_unit_metadata` is the metadata that would be merged into the buffer metadata\n     normally (if `alignment` was `:au`).\n  - `end_access_unit: true` - added for each NALu that ends an access unit.\n\n\n\n- `attach_nalus?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`  \n  Determines whether to attach NAL units list to the metadata when `alignment` option\n  is set to `:au`. For details see `t:Membrane.H264.nalu_in_metadata_t/0`.\n\n\n\n- `skip_until_keyframe?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`  \n  Determines whether to drop the stream until the first key frame is received.\n\n\n\n- `skip_until_parameters?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `true`  \n  Determines whether to drop the stream until the first set of SPS and PPS is received.\n\n\n\n- `max_frame_reorder`  \n\n  ```\n  non_neg_integer()\n  ```\n  \n  Default value: `15`  \n  Defines the maximum expected number of consequent b-frames in the stream.","ref":"Membrane.H264.FFmpeg.Parser.html#module-element-options","title":"Element options - Membrane.H264.FFmpeg.Parser","type":"module"},{"doc":"### `:input`\n\nAccepted formats:\n```\n%format{} when format in [Membrane.RemoteStream, H264, H264.RemoteStream]\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\nDemand unit: | `:buffers`\n\n\n### `:output`\n\nAccepted formats:\n```\n%H264{}\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`\nDemand unit: | `nil`","ref":"Membrane.H264.FFmpeg.Parser.html#module-pads","title":"Pads - Membrane.H264.FFmpeg.Parser","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.H264.FFmpeg.Parser.html#options/0","title":"Membrane.H264.FFmpeg.Parser.options/0","type":"function"},{"doc":"Struct containing options for `Membrane.H264.FFmpeg.Parser`","ref":"Membrane.H264.FFmpeg.Parser.html#t:t/0","title":"Membrane.H264.FFmpeg.Parser.t/0","type":"type"},{"doc":"Utility functions for parsing AVC Configuration Record","ref":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.html","title":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration","type":"module"},{"doc":"","ref":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.html#parse/1","title":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.parse/1","type":"function"},{"doc":"","ref":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.html#t:t/0","title":"Membrane.H264.FFmpeg.Parser.DecoderConfiguration.t/0","type":"type"},{"doc":"# Membrane H264 FFmpeg plugin\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_h264_ffmpeg_plugin.svg)](https://hex.pm/packages/membrane_h264_ffmpeg_plugin)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_h264_ffmpeg_plugin/)\n[![CircleCI](https://circleci.com/gh/membraneframework/membrane_h264_ffmpeg_plugin.svg?style=svg)](https://circleci.com/gh/membraneframework/membrane_h264_ffmpeg_plugin)\n\nThis package provides H264 video parser, decoder and encoder, based on [ffmpeg](https://www.ffmpeg.org)\nand [x264](https://www.videolan.org/developers/x264.html).\n\nIt is a part of the [Membrane Multimedia Framework](https://membraneframework.org)\n\nDocumentation is available at [HexDocs](https://hexdocs.pm/membrane_h264_ffmpeg_plugin/)","ref":"readme.html","title":"Membrane H264 FFmpeg plugin","type":"extras"},{"doc":"Add the following line to your `deps` in `mix.exs`. Run `mix deps.get`.\n\n```elixir\n{:membrane_h264_ffmpeg_plugin, \"~> 0.28.0\"}\n```\n\nYou also need to have [ffmpeg](https://www.ffmpeg.org) libraries installed in your system.\n\n#","ref":"readme.html#installation","title":"Installation - Membrane H264 FFmpeg plugin","type":"extras"},{"doc":"```bash\nsudo apt-get install libavcodec-dev libavformat-dev libavutil-dev\n```\n\n#","ref":"readme.html#ubuntu","title":"Ubuntu - Membrane H264 FFmpeg plugin","type":"extras"},{"doc":"```bash\npacman -S ffmpeg\n```\n\n#","ref":"readme.html#arch-manjaro","title":"Arch/Manjaro - Membrane H264 FFmpeg plugin","type":"extras"},{"doc":"```bash\nbrew install ffmpeg\n```","ref":"readme.html#macos","title":"MacOS - Membrane H264 FFmpeg plugin","type":"extras"},{"doc":"#","ref":"readme.html#usage-example","title":"Usage Example - Membrane H264 FFmpeg plugin","type":"extras"},{"doc":"The following pipeline takes 30fps H264 file and decodes it to the raw video.\n\n```elixir\ndefmodule Decoding.Pipeline do\n  use Membrane.Pipeline\n\n  @impl true\n  def handle_init(_ctx, _opts) do\n    structure =\n      child(:source, %Membrane.File.Source{chunk_size: 40_960, location: \"input.h264\"})\n      |> child(:parser, %H264.FFmpeg.Parser{framerate: {30, 1}})\n      |> child(:decoder, H264.FFmpeg.Decoder)\n      |> child(:sink,  %Membrane.File.Sink{location: \"output.raw\"})\n\n    {[spec: structure], %{}}\n  end\nend\n```\n\n`Membrane.H264.FFmpeg.Parser` is not actively developed and will soon be deprecated in favour of our pure Elixir implementation of the H264 parser. We encourage you to try out [`Membrane.H264.Parser`](https://hexdocs.pm/membrane_h264_plugin/Membrane.H264.Parser.html) from [membrane_h264_plugin](https://github.com/membraneframework/membrane_h264_plugin).\n\n#","ref":"readme.html#decoder","title":"Decoder - Membrane H264 FFmpeg plugin","type":"extras"},{"doc":"The following pipeline takes 720p raw video file as input and encodes it as H264.\n\n```elixir\ndefmodule Encoding.Pipeline do\n  use Membrane.Pipeline\n\n  @impl true\n  def handle_init(_) do\n    structure =\n      child(:source, %Membrane.File.Source{chunk_size: 40_960, location: \"input.raw\"})\n      |> child(:parser, %Membrane.RawVideo.Parser{width: 1280, height: 720, pixel_format: :I420})\n      |> child(:encoder, %Membrane.H264.FFmpeg.Encoder{preset: :fast, crf: 30})\n      |> child(:sink, %Membrane.File.Sink{location: \"output.h264\"})\n\n    {[spec: structure], %{}}\n  end\nend\n```","ref":"readme.html#encoder","title":"Encoder - Membrane H264 FFmpeg plugin","type":"extras"},{"doc":"Copyright 2018, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)","ref":"readme.html#copyright-and-license","title":"Copyright and License - Membrane H264 FFmpeg plugin","type":"extras"}]}